/**
 * Created by Sarthak on 11-02-2019.
 */
import {by, element, ElementArrayFinder, ElementFinder} from "protractor";
import {UiMap} from "./UiMap";
import {BasePage} from "./base";

export class ElementLocators {
    public uiMap=null;
    //Creating object of UiMap class to access Locators in the Page classes


    //Constructor used to initialize the page objects
    constructor() {
     this.uiMap = new UiMap();
    }


    findElementByPartialLinkText(partialLinkText: string) {
        return element(by.partialLinkText(partialLinkText));
    }

    findElementByTagName(tagName: string) {
        return element(by.tagName(tagName));
    }

    findElementByXpath(xpath: string) {
        return element(by.xpath(xpath));
    }

    findElementByJs(javaScriptExpressions: string) {
        return element(by.js(javaScriptExpressions));
    }

    findElementByLinkText(text: string) {
        return element(by.linkText(text))
    }

    findElementByID(id: string) {
        return element(by.id(id))
    }

    findElementByModel(model: string) {
        return element(by.model(model))
    }

    findElementByButtonText(buttonText: string) {
        return element(by.buttonText(buttonText))
    }

    findElementByClassName(className: string) {
        return element(by.className(className))
    }

    findElementByTextBinding(textBinding: string) {
        return element(by.binding(textBinding))
    }

    findElementByExactBinding(exactBinding: string) {
        return element(by.exactBinding(exactBinding))
    }

    findElementByRepeater(repeater: string) {
        return element(by.repeater(repeater))
    }

    findElementByExactRepeater(repeater: string) {
        return element(by.exactRepeater(repeater))
    }

    findElementByOptions(options: string) {
        return element.all(by.options(options))
    }

    findElementsByDeepCss(deepcss: string) {
        return element.all(by.deepCss(deepcss))
    }

    findElementByPartialButtonText(partialButtonText: string) {
        return element(by.partialButtonText(partialButtonText))
    }

    findElementByCssContainingText(cssSelector, searchString: string) {
        return element(by.cssContainingText(cssSelector, searchString))
    }

    findElementByCss(cssSelector: string) {
        return element(by.css(cssSelector));
    }

    findElementByName(name: string) {
        return element(by.name(name));
    }

    findElementByDataId(tag: string, dataID: string, option: string) {
        let ele: ElementFinder;
        switch (option.toLowerCase()) {
            case "css": {
                const selector = `${tag}[data-id="${dataID}"]`;
                ele = element(by.css(selector));
                break;
            }
            case "xpath": {
                ele = element(by.xpath('//\'' + tag + '\'' + '[@data-id=\'' + dataID + '\']'));
                break;
            }

        }
        return ele;
    }

    //Return elements
    findElementsByPartialLinkText(partialLinkText: string) {
        return element.all(by.partialLinkText(partialLinkText));
    }

    findElementsByTagName(tagName: string) {
        return element.all(by.tagName(tagName));
    }

    findElementsByXpath(xpath: string) {
        return element.all(by.xpath(xpath));
    }

    findElementsByJs(javaScriptExpressions: string) {
        return element.all(by.js(javaScriptExpressions));
    }

    findElementsByLinkText(text: string) {
        return element.all(by.linkText(text))
    }

    findElementsByID(id: string) {
        return element.all(by.id(id))
    }

    findElementsByModel(model: string) {
        return element.all(by.model(model))
    }

    findElementsByButtonText(buttonText: string) {
        return element.all(by.buttonText(buttonText))
    }

    findElementsByClassName(className: string) {
        return element.all(by.className(className))
    }

    findElementsByTextBinding(textBinding: string) {
        return element.all(by.binding(textBinding))
    }

    findElementsByExactBinding(exactBinding: string) {
        return element.all(by.exactBinding(exactBinding))
    }

    findElementsByRepeater(repeater: string) {
        return element.all(by.repeater(repeater))
    }

    findElementsByExactRepeater(repeater: string) {
        return element.all(by.exactRepeater(repeater))
    }

    findElementsByOptions(options: string) {
        return element.all(by.options(options))
    }


    findElementsByPartialButtonText(partialButtonText: string) {
        return element.all(by.partialButtonText(partialButtonText))
    }

    findElementsByCssContainingText(cssSelector, searchString: string) {
        return element.all(by.cssContainingText(cssSelector, searchString))
    }

    findElementsByCss(cssSelector: string) {
        return element.all(by.css(cssSelector));
    }

    findElementsByName(name: string) {
        return element.all(by.name(name));
    }

    findElementsByDataId(tag: string, dataID: string, option: string) {
        let ele: ElementArrayFinder;
        switch (option.toLowerCase()) {
            case "css": {
                const selector = `${tag}[data-id="${dataID}"]`;
                ele = element.all(by.css(selector));
                break;
            }
            case "xpath": {
                ele = element.all(by.xpath('//\'' + tag + '\'' + '[@data-id=\'' + dataID + '\']'));
                break;
            }

        }
        return ele;
    }

}