const { BeforeAll, After, AfterAll, Status } = require("cucumber");
import * as fs from "fs";
import { browser } from "protractor";
import { config } from "../config/config";
import {LoginPage} from "../app/pages/login/LoginPage";
let loginPage=new LoginPage();

BeforeAll({timeout: 1000 * 1000}, async () => {
    await browser.get(config.baseUrl);
    loginPage.login();
    await browser.sleep(40000);
});

After(async function(scenario) {
    if (scenario.result.status === Status.FAILED) {
        // screenShot is a base-64 encoded PNG
         const screenShot = await browser.takeScreenshot();
         this.attach(screenShot, "image/png");
    }
});

AfterAll({timeout: 100 * 1000}, async () => {
    await browser.quit();
});
